<?php
/*
Plugin Name: future-to-publish
Plugin URI: http://wordpress.org/#
Description: 予約投稿を解除するプラグイン
Author: kida
Version: 1
Author URI: http://pct.unifas.co.jp/
*/

add_filter('edit_form_advanced','InsertPostUI');
add_filter('edit_page_form','InsertPostUI');

add_filter('edit_post','UpdateEvaldState');
add_filter('publish_post','UpdateEvaldState');
add_filter('save_post','UpdateEvaldState');

add_filter('wp_insert_post_data', 'future_to_publish','10','2');

function future_to_publish($data,$postarr) {

	$post_id = $_POST['post_ID'];
	$action  = $_POST['action'];
	

	if(($post_id) && ($action === 'editpost')){
		if(!$postarr[post_category]){return $data;}
		if($_POST['ftop_eval'] === 'true'){
		$data['post_status'] = 'publish';
		}
	}

	return $data;
	

}

function InsertPostUI() {
global $wpdb;

         if (isset($_REQUEST['post'])) {
            $isEvald = IsPostEvald($_REQUEST['post']);
            $checked = ('1' == $isEvald) ? ' checked="checked" ' : '';
         }
         
         $wp_c_n = wp_create_nonce('ftop');

print<<<EOD
      <fieldset id="ftopdiv" class="dbx-box">
      <h3 class="dbx-handle">投稿予約を解除</h3>
      <div id="ftopUI" class="dbx-content">
         <label class="selectit">
         <input type="checkbox" name="ftop_eval"  value="true" {$checked}>投稿予約を解除してポストする</label>
         <input type="hidden" name="ftop-verify-key" id="ftop-verify-key" value="{$wp_c_n}" />
      </div>
      </fieldset>
EOD;
}


function UpdateEvaldState($id) {
global $wpdb;

      if (!wp_verify_nonce($_POST['ftop-verify-key'], 'ftop'))
         return;

      if (!isset($id))
         $id = $_REQUEST['post_ID'];

      // sanity check - id should _always_ be a number
      // todo: notify site owner?
      if (!is_numeric($id)) {
         die ("error: id is $id");
         $id = 0;
         return;
      }

      if (isset($_REQUEST['ftop_eval'])) {
         $qry = "DELETE FROM {$wpdb->postmeta}
                 WHERE Post_ID = " . $wpdb->escape($id) . "
                  AND meta_key = '" . ftop_metakey . "';";

         $wpdb->query($qry);

         $qry = "INSERT INTO {$wpdb->postmeta} (Post_ID, meta_key, meta_value)
                 VALUES (" . $wpdb->escape($id) . ",
                  '" . ftop_metakey . "', '1');";
         $wpdb->query($qry);
      }
      else {
         $qry = "DELETE FROM {$wpdb->postmeta}
                 WHERE Post_ID = " . $wpdb->escape($id) . "
                   AND meta_key = '" . ftop_metakey . "';";
         $wpdb->query($qry);
      }
}

   
function IsPostEvald($postID) {
global $wpdb;

      if (!is_numeric($postID)) {
         //return false;
         die("Error from runPHP: postID ($postID) must be an integer. Aborting.");
      }

      return $wpdb->get_var("SELECT meta_value
                             FROM {$wpdb->postmeta}
                             WHERE Post_ID = " . $wpdb->escape($postID) . "
                             AND meta_key = '" . ftop_metakey . "';");
}

?>
